import 'dart:html';
import 'package:trotter/trotter.dart';

void main() {
  var sprites = new ImageElement(src: "piggy_sprites.png");
  var draw = (combinatoric) {
    int n = combinatoric.length;
    print(n);
    final int WIDTH = 250, HEIGHT = n * 50;
    var 
      pPic = new CanvasElement(width: WIDTH, height: HEIGHT),
      context = pPic.getContext("2d") as CanvasRenderingContext2D;
    for (int row = 0; row < n; row++) {
      for (int col = 0; col < combinatoric[row].length; col++) {
        context.drawImageToRect(sprites, 
          new Rectangle(
            col * (WIDTH ~/ 5), 
            row * (HEIGHT ~/ n), 
            WIDTH ~/ 5,
            HEIGHT ~/ n
          ),
          sourceRect: new Rectangle(
           combinatoric[row][col] * 100,
           0,
           100, 
           100
          )
        );
      }
    }
    document.body.children.add(pPic);
  }, title = (String t) {
    document.body.children
     ..add(new Element.html("<h2>$t:</h2>"))
     ..add(new Element.html("<br/>"));
  };
  
  sprites.onLoad.listen((_) {
    var frames = new List<int>.generate(5, (int i) => i);
    title("3-Permutations");
    var p = new Permutations(3, frames);
    draw(p);
    title("3-Combinations");
    var c = new Combinations(3, frames);
    draw(c);
    title("3-Amalgams");
    var a = new Amalgams(3, frames);
    draw(a);
    title("3-Selections");
    var s = new Selections(3, frames);
    draw(s);
    title("Subsets");
    var ss = new Subsets(frames);
    draw(ss);
  });
}

